throw

UWAGA: Tłumaczenie tej strony nie zostało zakończone.
Może być ona niekompletna lub wymagać korekty.
Chcesz pomóc? | Dokończ tłumaczenie | Sprawdź ortografię | Więcej takich stron+.

Podsumowanie

Rzuca wyjątek zdefiniowany przez użytkownika.

Instrukcja
Zaimplementowana w: JavaScript 1.4
Wersja ECMA: ECMA-262, Edycja 3

Składnia

throw  expression ;

Parametry

expression
Wyrażenie będące wynikiem rzucenia wyjątku.

Opis

Use the throw statement to throw an exception. When you throw an exception, expression specifies the value of the exception. Each of the following throws an exception:

  • throw "Error2"; // generuje wyjątek będący napisem "Error2"
  • throw 42; // generuje wyjątek mający wartość będącą liczbą 42
  • throw true; // generuje wyjątek o wartości true

Przykłady

Przykład: Rzucanie wyjątkiem będącym obiektem

You can specify an object when you throw an exception. You can then reference the object's properties in the catch block. The following example creates an object myUserException of type UserException and uses it in a throw statement.

function UserException(message) {
   this.message = message;
   this.name = "UserException";
}
function getMonthName(mo) {
   mo = mo-1; // Adjust month number for array index (1=Jan, 12=Dec)
   var months = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
      "Aug", "Sep", "Oct", "Nov", "Dec");
   if (months[mo] != null) {
      return months[mo];
   } else {
      myUserException = new UserException("InvalidMonthNo");
      throw myUserException;
   }
}

try {
   // statements to try
   monthName = getMonthName(myMonth);
} catch (e) {
   monthName = "unknown";
   logMyErrors(e.message, e.name); // pass exception object to err handler
}

Przykład: Inny przykład rzucania wyjątku będacego obiektem

Poniższy kod sprawdza czy wprowadzony napis jest kodem pocztowym U.S. Jeżeli kod pocztowy ma niepoprawny format, to instrukcja throw rzuca wyjątek w postaci obiektu ZipCodeFormatException.

/*
 * Creates a ZipCode object.
 *
 * Accepted formats for a zip code are:
 *    12345
 *    12345-6789
 *    123456789
 *    12345 6789
 *
 * If the argument passed to the ZipCode constructor does not
 * conform to one of these patterns, an exception is thrown.
 */

function ZipCode(zip) {
   zip = new String(zip);
   pattern = /[0-9]{5}([- ]?[0-9]{4})?/;
   if (pattern.test(zip)) {
      // zip code value will be the first match in the string
      this.value = zip.match(pattern)[0];
      this.valueOf = function() {
         return this.value
      };
      this.toString = function() {
         return String(this.value)
      };
   } else {
      throw new ZipCodeFormatException(zip);
   }
}

function ZipCodeFormatException(value) {
   this.value = value;
   this.message = "does not conform to the expected format for a zip code";
   this.toString = function() {
      return this.value + this.message
   };
}

/*
 * This could be in a script that validates address data
 * for US addresses.
 */

var ZIPCODE_INVALID = -1;
var ZIPCODE_UNKNOWN_ERROR = -2;

function verifyZipCode(z) {
   try {
      z = new ZipCode(z);
   } catch (e) {
      if (e instanceof ZipCodeFormatException) {
         return ZIPCODE_INVALID;
      } else {
         return ZIPCODE_UNKNOWN_ERROR;
      }
   }
   return z;
}

a = verifyZipCode(95060);         // returns 95060
b = verifyZipCode(9560;)          // returns -1
c = verifyZipCode("a");           // returns -1
d = verifyZipCode("95060");       // returns 95060
e = verifyZipCode("95060 1234");  // returns 95060 1234

Przykład: Powtórne rzucenie wyjątkiem

Możesz użyć instrukcji throw by ponownie rzucić wyjątkiem, który złapałeś. W poniższym przykładzie łapiemy wyjątek będący liczbą i jeżeli jego wartość wynosi nie więcej niż 50, to rzucamy wyjątek ponownie. The rethrown exception propagates up to the enclosing function or to the top level so that the user sees it.

try {
   throw n; // rzuca wyjątkiem mającym wartość numeryczną
} catch (e) {
   if (e <= 50) {
      // wyrażenia wykonane gdy wartość wyjątku wynosi 1-50
   } else {
      // nie możemy obsłużyć tego wyjątku, rzucamy ponownie
      throw e;
   }
}

Zobacz także

Budowe bloku try...catch

 

 

 

Autorzy i etykiety dokumentu

 Autorzy tej strony: teoli, Rokuzo, Mgjbot, Ptak82, Diablownik
 Ostatnia aktualizacja: teoli,